---
title: KeyframeEffectOptions
slug: Web/API/KeyframeEffectOptions
tags:
  - API
  - Dictionary
  - Draft
  - EffectTiming
  - Experimental
  - KeyframeEffect
  - KeyframeEffectOptions
  - NeedsCompatTable
  - Reference
  - Web Animations
---
<p>{{APIRef("Web Animations")}}{{Draft}}{{SeeCompatTable}}</p>

<p class="summary">The <strong><code>KeyframeEffectOptions</code></strong> dictionary, part of the {{DOMxRef('Web Animations API', '', '', 'true')}}, is used by {{DOMxRef('Element.animate()')}}, {{DOMxRef('KeyframeEffectReadOnly.KeyframeEffectReadOnly', 'KeyframeEffectReadOnly()')}} and {{DOMxRef('KeyframeEffect.KeyframeEffect', 'KeyframeEffect()')}} to describe timing properties for animation effects. These properties are all optional, although without setting a <code>duration</code> the animation will not play.</p>

<p>In other words, these properties describe how the {{Glossary("user agent")}} should go about making the transition from keyframe to keyframe, and how to behave when the animation begins and ends.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt><code>composite</code> {{Experimental_Inline}} {{Optional_Inline}}</dt>
 <dd>Determines how values are combined between this animation and other, separate animations that do not specify their own specific composite operation. Defaults to <code>replace</code>.
 <ul>
  <li><code>add</code> dictates an additive effect, where each successive iteration builds on the last. For instance with <code>transform</code>, a <code>translateX(-200px)</code> would not override an earlier <code>rotate(20deg)</code> value but result in <code>translateX(-200px) rotate(20deg)</code>.</li>
  <li><code>accumulate</code> is similar but a little smarter: <code>blur(2)</code> and <code>blur(5)</code> become <code>blur(7)</code>, not <code>blur(2) blur(5)</code>.</li>
  <li><code>replace</code> overwrites the previous value with the new one.</li>
 </ul>
 </dd>
 <dt><code>iterationComposite</code> {{Experimental_Inline}} {{Optional_Inline}}</dt>
 <dd>Determines how values build from iteration to iteration in this animation. Can be set to <code>accumulate</code> or <code>replace</code> (see above). Defaults to <code>replace</code>.</dd>
 <dt><code>pseudoElement</code> {{Experimental_Inline}} {{Optional_Inline}}</dt>
 <dd>The selector of the pseudo-element to be targeted, if any. Defaults to <code>null</code>.</dd>
 <dd>{{Page("/en-US/docs/Web/API/Web_Animations_API/Animation_timing_properties", "Properties")}}</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Web Animations 2', '#the-keyframeeffectoptions-dictionary', 'KeyframeEffectOptions' )}}</td>
   <td>{{Spec2('Web Animations 2')}}</td>
   <td>Added the <code>iterationComposite</code> option.</td>
  </tr>
  <tr>
   <td>{{SpecName('Web Animations', '#the-keyframeeffectoptions-dictionary', 'KeyframeEffectOptions' )}}</td>
   <td>{{Spec2('Web Animations')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.KeyframeEffectOptions")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("EffectTiming")}}</li>
 <li>{{DOMxRef('Web Animations API', '', '', 'true')}}</li>
 <li>{{DOMxRef('Web Animations API.Using the Web Animations API', 'Using the Web Animations API', '', 'true')}}</li>
 <li>{{DOMxRef('Element.animate()')}}</li>
 <li>{{DOMxRef('KeyframeEffect.KeyframeEffect', 'KeyframeEffect()')}}</li>
 <li>{{DOMxRef('KeyframeEffectReadOnly.KeyframeEffectReadOnly', 'KeyframeEffectReadOnly()')}}</li>
</ul>
